import load from 'load-script';

export default function (Vue, script, objectName) {
    let obj = () => window[objectName];

    if (!obj()) {
        load(script, function (err, script) {
            if (err) console.error("script error: ", err, script);
        });
    }

    Vue.mixins({
        methods: {
            ['$' + objectName](apiKey) {
                let cached = null;
                let callFn = () => {
                    return new Promise((resolve) => {
                        let init = () => {
                            let objClass = obj();
                            if (objClass) {
                                resolve(cached = new objClass(apiKey));
                            } else {
                                setTimeout(() => init(), 1000)
                            }
                        };

                        if (cached) {
                            resolve(cached);
                        } else {
                            init();
                        }
                    });
                };

                return new Proxy({}, {
                    get: (t, name) => (...args) => {
                        return new Promise((resolve, reject) => {
                            callFn().then((i) => {
                                if (i[name]) {
                                    i[name](args).then((...a) => resolve.apply(this, a)).catch((...e) => reject.apply(this, a));
                                } else {
                                    console.error(`${name} does not exists in ${objectName}`);
                                }
                            });
                        });
                    }
                });
            },
        }
    })
};